﻿using Microsoft.Extensions.Hosting;
using StackExchange.Redis;
using System;
using System.Threading;
using System.Threading.Tasks;
using Wisej.Web;

namespace WisejWebDesktopAppQueue {
    public class RedisSubscriver : BackgroundService {
        private readonly IConnectionMultiplexer connectionMultiplexer;

        public RedisSubscriver() {
            connectionMultiplexer = Application.Services.GetService<IConnectionMultiplexer>();
        }

        protected override Task ExecuteAsync(CancellationToken stoppingToken) {
            var subscriver = connectionMultiplexer.GetSubscriber();

            return subscriver.SubscribeAsync("messages", (ch, value) => {
                var toast = new Toast(value);
                toast.Show();
            });
        }
    }
}
